#include <locale.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

GtkWidget *label;                          // метка
GTimeVal start;

gpointer thread_func( gpointer data ) {    // потоковая функция;
   GTimeVal current;
   char msg[ 40 ]; 
   while( 1 ) {
      g_usleep( 1000000 );                 // ожидание 1 сек.
      g_get_current_time( &current );      // текущее время
      g_sprintf( msg, "прошло %lu секунд", current.tv_sec - start.tv_sec ); 
      gdk_threads_enter();                 // вход в критическую секцию
      gtk_label_set_text( (GtkLabel*)label, msg );
      gdk_threads_leave();                 // выход из критической секции
   }
   return 0;
}

int main( int argc, char *argv[] ) {
   GtkWindow *window;                      // главное окно
   if( !g_thread_supported() ) {           // инициализация потоков
      g_thread_init( NULL );
      gdk_threads_init();                  // для работы gdk_threads_enter() и gdk_threads_leave()
   }
   gtk_init( &argc, &argv );
   window = (GtkWindow*)gtk_window_new( GTK_WINDOW_TOPLEVEL ); 
   gtk_window_set_title( window, "прошедшее время..." ); 
   gtk_window_resize( window, 400, 100 );
   label = gtk_label_new( "стартовая метка" );          // создание пользовательского интерфейса ...
   gtk_container_add( GTK_CONTAINER( window ), label ); 
   g_signal_connect( G_OBJECT( window ), "destroy",     // соединяем сигнал завершения с выходом из программы
                     G_CALLBACK( gtk_main_quit ), NULL );
   g_get_current_time( &start );      
   gdk_threads_enter();                                 // вход в критическую секцию
   gtk_widget_show_all( (GtkWidget*)window );           // показываем окно вместе с виджетами
   g_thread_create( thread_func, NULL, FALSE, NULL );   // создаём дополнительный поток
   gtk_main();
   gdk_threads_leave();                                 // выход из критической секции
   return 0;
}
